package code;

import heap.*;
import java.util.*;

import output.FileOutput;


public class CNAsgn extends CodeNode  implements Statement{
	private Statement next;

	public CNAsgn(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		int t;
		CodeNode n = (CodeNode)this.jjtGetChild(0);
		t = n.typeCheck(types);
		if(t == UNCHECKED)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}
		n = (CodeNode)this.jjtGetChild(1);
		if(t != n.typeCheck(types))
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}		
		this.type = STATEMENT;
		return STATEMENT;
	}

	public String leftId()
	{
		return ((CNId)this.jjtGetChild(0)).name();
	}

	public String rightId()
	{
		return ((CNId)this.jjtGetChild(1)).name();
	}

	public Statement next(boolean guard) {
		return next;
	}

	public Statement next()
	{
		return next;
	}

	public void setNext(Statement s)
	{
		next = s;
	}

	public int next(Heap h)
	{
		return true_;
	}

	public int instruction(Heap h)
	{
		if(((CodeNode)this.jjtGetChild(0)).type() == code.CodeNode.INTEGER)
		{
			// x = 20
			return asgn_xint;
		}
		else
		{
			if(!((CNId)this.jjtGetChild(0)).next())
			{
				if(this.jjtGetChild(1) instanceof CNNull)
				{
					// x = null
					return asgn_xnull;
				}
				else if(this.jjtGetChild(1) instanceof CNNew)
				{
					//x = new
					return asgn_xnew;
				}
				else if(this.jjtGetChild(1) instanceof CNId)
				{
					if(((CNId)this.jjtGetChild(0)).name().equals(((CNId)this.jjtGetChild(1)).name()))
					{
						if(((CNId)this.jjtGetChild(1)).next())
						{
							// x = x.next
							Root rx = new Root(((CNId)this.jjtGetChild(0)).name());
							Vertex vx = h.getVertex(rx);
							if(vx != null)
								return asgn_xxnext;
							else
								return error;							
						}
						else
						{
							// x = x
							return asgn_xx;
						}
					}
					else
					{
						if(!((CNId)this.jjtGetChild(1)).next())
						{
							// x = y
							Root ry = new Root(((CNId)this.jjtGetChild(1)).name());
							Vertex vy = h.getVertex(ry);
							if(vy != null)
								return asgn_xy;
							else
								return asgn_xnull;
						}
						else
						{
							// x = y.next
							Root ry = new Root(((CNId)this.jjtGetChild(1)).name());
							Vertex vy = h.getVertex(ry);
							if(vy != null)
								return asgn_xynext;
							else
								return error;
						}
					}					
				}
				else
					return error;
			}
			else
			{
				Root rx = new Root(((CNId)this.jjtGetChild(0)).name());
				Vertex vx = h.getVertex(rx);
				if(vx != null)
				{
					if(this.jjtGetChild(1) instanceof CNNull || (this.jjtGetChild(1) instanceof CNId && h.getVertex(new Root(((CNId)this.jjtGetChild(1)).name()))==null))
						return asgn_xnextnull;
					else if(this.jjtGetChild(1) instanceof CNId)
						return asgn_xnexty;
					else
						return error;
				}
				else
					return error;
			}		
		}
	}

	public String out(FileOutput module) {
		String s = new String();
		s = ((CodeNode)this.jjtGetChild(0)).out(module);
		String left = " ";
		for(int i = 1;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			left += n.out(module);
		}
		return s + module.asgn() + left;
	}

}
