package code;

import heap.*;

import java.util.Map;

import output.FileOutput;

public class CNId extends CodeNode implements Expression{
	private String name;
	private boolean next;
	
	public CNId(int i)
	{
		super(i);
	}
	
	public void setName(String n)
	{
		name = n;
	}
	
	public String name()
	{
		return name;
	}
	
	public int typeCheck(Map types)
	{
		int t;
		if(types.get(name) == null)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}
		t = ((Integer)types.get(name)).intValue();
		this.type = t;
		return t;
	}
	
	public void setNext(boolean b)
	{
		next = b;
	}
	
	public boolean next()
	{
		return next;
	}
	
	public String out(FileOutput module){
		return name;
	}

	public int evaluate(Heap h) {
		if(!isPure())
			return double_;
		else
		{
			Root r = new Root(name);
			Vertex v = h.getVertex(r);
			if(v == null)
				return false_;
			else
				return true_;
		}
	}

	public boolean isPure() {
		return this.type() == POINTER;
	}
	
	public boolean equals(Object o)
	{
		if(!(o instanceof CNId))
			return false;
		CNId other = (CNId)o;
		return name.equals(other.name) && this.next == other.next;
	}
}
