package code;

import heap.Heap;

import java.util.Map;

import output.FileOutput;

public class CNInt extends CodeNode implements Expression{
	private int value;

	public CNInt(int i)
	{
		super(i);
	}
	
	public void setValue(int i)
	{
		value = i;
	}
	
	public int value()
	{
		return value;
	}
	
	public int typeCheck(Map types)
	{
		return INTEGER; /* integer */
	}

	public String out(FileOutput module) {
		return String.valueOf(value);
	}
	
	public int evaluate(Heap h) {
		return double_;
	}

	public boolean isPure() {
		return false;
	}
	
	public boolean equals(Object o)
	{
		if(o.getClass() != this.getClass())
			return false;
		CNInt other = (CNInt)o;
		return other.value == this.value;
	}
}
