package code;

import heap.Heap;

import java.util.Map;

import output.FileOutput;

public class CNWhile extends CodeNode implements Statement{
	private Statement nexttrue;
	private Statement nextfalse;
	
	public CNWhile(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		if(((CodeNode)this.jjtGetChild(0)).typeCheck(types) != BOOLEAN)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}
		if(((CodeNode)this.jjtGetChild(1)).typeCheck(types) != STATEMENT)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}		
		this.type = STATEMENT;
		return STATEMENT;	
	}
	
	public Statement next()
	{
		return nexttrue;
	}
	
	public Statement next(boolean guard)
	{
		return guard?nexttrue:nextfalse;
	}
	
	public void setNext(Statement next)
	{
		nexttrue = (Statement)this.jjtGetChild(1);
		nextfalse = next;
		nexttrue.setNext(this);
	}

	public int instruction(Heap h)
	{
		return while_;
	}
	
	public int next(Heap h)
	{
		Expression e = (Expression)this.jjtGetChild(0);
		if(e.isPure())
		{
			if(e.evaluate(h) == Expression.true_)
				return true_;
			else
				return false_;
		}
		else
			return double_;
			
	}
	
	public String out(FileOutput module) {
		return "";
	}
	
	
}
