package output;
import automaton.*;

public interface FileOutput {
	
	public void open(String name) throws java.io.FileNotFoundException;
	
	public void close();
	
	public String filename();
	
	public void write(Automaton a);
	
	public String add();
	
	public String and();
	
	public String asgn();
	
	public String eq();
	
	public String ge();
	
	public String gt();
	
	public String le();
	
	public String lt();
	
	public String mult();
	
	public String not();
	
	public String or();
	
	public String slist();
	
	public String sub();
	
	public String Null();
	
	public String New();
	
	public String leftP();
	
	public String rightP();
	
	/** Does this fileformat support guards on pointer variables ?
	 *  Obviously, only helpers formats (Dot-like) return true. 
	 */
	public boolean pointerGuards();
	
	/** Does this fileformat support negation of expression ?
	 *  If true we can use switchNot to print "pretty" expression
	 *  If false just print negations
	 */
	public boolean supportSwitch();
	
	/** Make this module return negation of boolean operators previously returned
	 *  E.g if or returned C-like OR operator (" || ") now it returns " && ". 
	 */
	public void switchNot();
}
