package util;
import java.util.*;

public class EquivalenceList extends LinkedList {
	private static final long serialVersionUID = -3875475922588362541L;

	public EquivalenceList() {
		super();
	}

	public EquivalenceList(Collection arg0) {
		super(arg0);
	}

	public boolean contains(Object o)
	{
		if(o == null)
			return false;
		
		Iterator i = this.iterator();
		while(i.hasNext())
		{
			Equivalent c = (Equivalent)i.next();
			if(c.isEquivalentTo(o)!= null)
				return true;
		}
		return false;
	}
	
	public Equivalent getFirstEquivalent(Object o)
	{
		if(o == null)
			return null;
		
		Iterator i = this.iterator();
		while(i.hasNext())
		{
			Equivalent c = (Equivalent)i.next();
			if(c.isEquivalentTo(o)!= null)
				return c;
		}
		return null;
	}
	
	public boolean add(Object o)
	{
		if(o == null)
			return false;
		
		Equivalent e = (Equivalent)o;
		
		return super.add(e);
	}
	
}
