package util;
import java.util.*;

/** A class implements this interface to indicate that the method isEquivalentTo(Object) can be used.
 *  This method is used to represent the equivalence between object that Object.equals(Object) may not see.
 *  Considers this interface as a way to perform approximative equality without overiding equals method.
 * 
 * 
 * @author Swann Perarnau
 * @version 0.1
 * */
public interface Equivalent {

	/** Stub object to represent equality */
	public static final Object Identity = new HashMap();
	
	/** Compares the current object with the argument and provides a representation of the equivalence if it exists.
	 * @param o the object which to compare to.
	 * @return a representation of the equivalence if the two objects are equivalent, null if not.*/
	public Object isEquivalentTo(Object o);
	
	
}
